 // 3-Digit 7-segment display counter
 // Used microcontroller: PIC12F1822
 // Written by: BENCHEROUDA Okba
 // electronnote@gmail.com
 // http://elecnote.blogspot.com/
 // Internal oscillator used @ 32MHz
 // Use at your own risk

unsigned short j, digit;
bit st;
unsigned i;
unsigned short mask(unsigned short num) {
switch (num) {
   case 0 : return 0xC0;
   case 1 : return 0xF9;
   case 2 : return 0xA4;
   case 3 : return 0xB0;
   case 4 : return 0x99;
   case 5 : return 0x92;
   case 6 : return 0x82;
   case 7 : return 0xF8;
   case 8 : return 0x80;
   case 9 : return 0x90;
  }
}
void main() {
 OSCCON = 0xF0; // Internal oscillator 8MHz and PLL enabled (gives 32MHz)
 ANSELA = 0;    // All I/O pins are configured as digital
 ADCON0 = 0;    // Disable ADC module
 PORTA = 0;     // Initial value of port A bits
 TRISA = 8;
 OPTION_REG = 0;
 WPUA = 8;     // Enable pull-up resistor for RA3
  PORTA = 7;
 while(1){
  if (PORTA.F3)
  st = 1;
  if(st == 1)
  if (!PORTA.F3){
   i++;
   st = 0;
   }
  if (i > 999)
    i = 0;
  PORTA = 7;            // Turn off all displays
  digit = i % 10;
  digit = mask(digit);
  for ( j = 1; j < 0x80; j = j << 1){
    if(digit & j)
      PORTA.F4 = 1;
    else
      PORTA.F4 = 0;
    Delay_us(10);
    PORTA.F5 = 1;
    Delay_us(10);
    PORTA.F5 = 0;
  }
  PORTA = 3;            // Turn on display for ones
  Delay_ms(5);
  PORTA = 7;             // Turn off all displays
  digit = (i / 10) % 10;
  digit = mask(digit);
  for ( j = 1; j < 0x80; j = j << 1){
    if(digit & j)
      PORTA.F4 = 1;
    else
      PORTA.F4 = 0;
    Delay_us(10);
    PORTA.F5 = 1;
    Delay_us(10);
    PORTA.F5 = 0;
  }
  PORTA = 5;            // Turn on display for tens
  Delay_ms(5);
  PORTA = 7;             // Turn off all displays
  digit = (i /100) % 10;
  digit = mask(digit);
  for ( j = 1; j < 0x80; j = j << 1){
    if(digit & j)
      PORTA.F4 = 1;
    else
      PORTA.F4 = 0;
    Delay_us(10);
    PORTA.F5 = 1;
    Delay_us(10);
    PORTA.F5 = 0;
  }
  PORTA = 6;           // Turn on display for hundreds
  Delay_ms(5);
 }
}